-- Ŀ
--  ECGI-Lib.E V1.01 2002 Euphoria / Common Gateway Interface                
-- 
-- By Peter Blue
-- This can be used with normal CGI or EGI (Euphoria Gateway Interface)

include wildcard.e -- Part of the standard Euphoria instalation

global function EcgiGetKey(sequence qs,sequence key,integer stop)
  sequence q,qs2
  integer  qsl -- Query string length
  integer  kyl -- Key word length
  integer  ptr,pt2 -- Pointers
  
  q = ""  
  key = lower(key)
  qs2 = lower(qs) -- Easier to search if in same case
  
  qsl = length(qs)
  kyl = length(key)
  if (qsl + kyl) > 0 then
    ptr = match(key,qs2)
    if ptr > 0 then -- Found key
      pt2 = qsl -- Point to end of string
      for i = ptr to qsl do -- Look for 'stop' char (Cr/Lf/&)
        if qs2[i] = stop then -- Found it
          pt2 = i - 1
          exit
        end if
      end for
      ptr = ptr + kyl -- Step over key
      if qs[ptr] = ' ' then -- Step over space
        ptr = ptr + 1
      end if
      q = qs[ptr..pt2] -- Select raw data
    end if
  end if
  
  return q
end function


-- Convert this - arg1=value1&arg2=value2
--      to this - { {"arg1","value1"},{"arg2","value2"} }
global function EcgiSplitString(sequence txt)
  sequence q,key,tmp
  integer len,byt
  
  tmp = {}
  q = {}
  
  len = length(txt)
  for i = 1 to len do -- Scan along text
    byt = txt[i]
    if byt = '=' then -- End of key
      key = tmp
      tmp = {}
    elsif byt = '&' then -- End of value
      q = q & {{key,tmp}}
      key = {}
      tmp = {}
    else
      tmp = tmp & byt
    end if
  end for
  q = q & {{key,tmp}} -- Flush last entry

  return q
end function

-- eg %20 = space
global function EcgiHexToAscii(sequence hex)
  integer asc,base,byt,v

  asc = 0
  base = 1
  for i = 1 to length(hex) do
    asc = asc * base
    base = base * 16
    byt = hex[i]
    if (byt >= '0') and (byt <= '9') then
      v = byt - '0'
    else
      v = byt - 'A' + 10
    end if
    asc = asc + v
  end for

  return asc
end function


global function EcgiTidyString(sequence qs1)
  sequence qs2,hex
  integer idx,len,byt

  qs2 = ""
  len = length(qs1)
  idx = 1
  while idx <= len do -- Tidy-up data
    byt = qs1[idx]
    if byt = '+' then
      qs2 = qs2 & " "
    elsif byt = '%' then
      hex = qs1[idx+1..idx+2]
      qs2 = qs2 & EcgiHexToAscii(hex)
      idx = idx + 2
    else
      qs2 = qs2 & byt
    end if
    idx = idx + 1
  end while

  return qs2
end function

-- This is used to extract normal CGI GET/POST data from server
global function EcgiQueryString()
  integer l
  object qs
  
  qs = getenv("QUERY_STRING") -- Input query string
  if atom(qs) then -- Get data from POST method
    qs = gets(0)
    l = length(qs)
    if qs[l] = 10 then -- Strip trailing LF
      qs = qs[1..l-1]
    end if
  end if
  
  return EcgiTidyString(qs)
end function
