-- Ŀ
--  HTTP-Lib.E X1.01 (C) 2002 Peter Blue <Peter.Blue@legend-i.demon.co.uk>   
--  Experimental DOS32/Win32/Linux HTTP Library                              
--                                                                           
-- 
-- This was ported from a web server writen in VB5

include WildCard.e
include HTML-Lib.e -- 

global integer  HttpPort         HttpPort = 80
global sequence HttpLocalPath    HttpLocalPath = "" -- Path to web site
global sequence HttpLogPath      HttpLogPath = "" -- Path to log files
global sequence HttpDefaultPage  HttpDefaultPage = "index.htm" -- Changable
global sequence HttpOS           HttpOS = "!"
global integer  HttpOSID         HttpOSID = platform()
global integer  HttpPageHits     HttpPageHits = 0
global integer  HttpFileHits     HttpFileHits = 0
global constant HttpLibVer = "X1.01" -- Experimental

-- Make above variables available to these functions
include ECGI-Lib.e -- Generic CGI / EGI functions
include HTTP-EGI.e -- EGI 'Bolt-on' functions


constant crlf  = 13 & 10
constant crlf2 = 13 & 10 & 13 & 10 -- Used for breaking-up POST data

sequence ReturnCode	  ReturnCode = repeat({},500)

constant MonthList =
  {"jan","feb","mar","apr","may","jun","jul","aug","sep","oct","nov","dec"}

constant WeekDay = {"sun","mon","tue","wed","thu","fri","sat"}

function HttpVal(sequence txt)
  integer  n
  sequence v
  
  n = 0
  v = value(txt)
  if v[1] = GET_SUCCESS then
    n = v[2]
  end if
  
  return n
end function

-- Return current date/time
-- {year,month,day,hour,minute,second}
global function HttpNow()
  sequence dt
  
  dt = date()
  dt[1] = dt[1] + 1900
  
  return dt[1..6] -- Don't need weekday
end function


-- Convert internal date/time to Internet format
-- {year,month,day,hour,minute,second,week-day}
function HttpInetDate(sequence dt)
  integer  i
  sequence w,m

  i = 1  w = "Sun" -- Default
  if length(dt) >= 7 then -- Weekday was supplied ..
    i = dt[7] -- .. so use it
    w = WeekDay[i]
    w[1] = w[1] - 32 -- eg mon = Mon
  end if
  
  i = dt[2]
  m = MonthList[i] -- in lower case
  m[1] = m[1] - 32 -- to upper case. eg jan = Jan
  
  return sprintf("%s, %02d %s %04d %02d:%02d:%02d GMT",
   {w,dt[3],m,dt[1],dt[4],dt[5],dt[6]})
end function
-- eg Sun, 18 Nov 2002 12:10:30 GMT


procedure HttpDebug(sequence txt)
  integer h
  
  h = open("HTTP-Lib.LOG","ab")
  if h > 0 then -- Write dialog
    printf(h,"Debug: %s\n",{txt})
    close(h)
  end if
end procedure


-- Process 'GET' command
function HttpGetDialog(sequence url,sequence head)
  sequence q,z,e,tmp,d,mm
  sequence ct  -- Content type
  sequence fn  -- File name
  sequence ft  -- File type
  sequence dt  -- File date-time
  sequence qs  -- Query string
  sequence ims -- If-Modified-Since Date-Time
  integer  rc  -- Result code (ie 200,404 ...)
  integer  len,h,byt,tln,ok
  integer  yr,mn,dy,hr,mi,se -- Date time
  
  rc = -1
  if compare(url,"/") = 0 then -- Assume default index page
    url = "/" & HttpDefaultPage
  end if
  
  qs = "" -- Query string ie /page.egi?arg1=val1
  len = length(url)
-- eg /database.egi?name=peter+blue&tel=762345
  for i = 1 to len do -- Scan along URL
    if url[i] = '?' then       -- Query string found
      tmp = url[i+1..len]      -- = name=peter+blue&tel=762345
      qs = EcgiTidyString(tmp) -- = name=peter blue&tel=762345
      url = url[1..i-1]        -- =/database.egi
      len = i - 1
      exit -- Bail out here
    end if
  end for
  
  
  ims = {} -- "If-Modified-Since" date/time
  tmp = EcgiGetKey(head,"if-modified-since:",13)
  tln = length(tmp)
  
  if tln > 25 then -- Valid date/time
  -- Convert Internet date/time format (RFC 1123) into something more usable
  -- Example: Sat, 29 Oct 1994 19:43:31 GMT
    d = ""
    for i = 1 to tln do -- Scan along date/time
      if tmp[i] = ' ' then -- Step over weekday
        d = tmp[i+1..tln]
        exit -- d = 29 Oct 1994 19:43:31 GMT
      end if
    end for
    yr = HttpVal(d[8..11])  -- Year
    
    mm = lower(d[4..6])     -- Month
    mn = 1 -- Safe default to Jan
    for i = 1 to 12 do -- Scan month list
      if compare(mm,MonthList[i]) = 0 then -- Found month in list
        mn = i  exit -- Just need month number
      end if
    end for
    
    dy = HttpVal(d[1..2])   -- Day
    hr = HttpVal(d[13..14]) -- Hour
    mi = HttpVal(d[16..17]) -- Minute
    se = HttpVal(d[19..20]) -- Second
    ims = {yr,mn,dy,hr,mi,se} --  Easy format to compare later
  end if

  e  = ".egi" -- Extension, assume EGI
  for i = len to 1 by -1 do -- Scan down URL to find extension
    if url[i] = '.' then
      e = lower(url[i..len])
      exit
    end if
  end for
  
  q  = {rc,"","",""} -- Default
  ct = ""
  dt = ""
  ft = "" -- Default: No need to load any file
  if    compare(e,".htm") = 0  then -- Web page
    ct = "text/html"
    ft = "r" -- Indicates need to load text file
    HttpPageHits += 1
    
  elsif compare(e,".html") = 0 then -- Web page
    ct = "text/html"
    ft = "r"
    HttpPageHits += 1
    
  elsif compare(e,".xml") = 0 then -- XML page
    ct = "text/xml"
    ft = "r"
    HttpPageHits += 1
    
  elsif compare(e,".gif") = 0  then -- GIF image
    ct = "image/gif"
    ft = "rb" -- Indicates need to load binary file
    HttpFileHits += 1
    
  elsif compare(e,".jpg") = 0  then -- JPEG image
    ct = "image/jpeg"
    ft = "rb" -- Here too ..
    HttpFileHits += 1
    
  elsif compare(e,".jpeg") = 0 then -- JPEG image
    ct = "image/jpeg"
    ft = "rb" -- And here ..
    HttpFileHits += 1
    
  elsif compare(e,".eds") = 0  then -- EDS (Eu Database)
    -- Awaiting inspiration !!
    HttpPageHits += 1
    
  elsif compare(e,".egi") = 0  then -- Euphoria Gateway Interface
    HttpPageHits += 1
    q = HttpProcessEGI(url,qs,head) -- Defined in 'HTTP-EGI.e'
    
  else -- Some other kind of binary file
    HttpFileHits += 1
    ct = "*/*"
    ft = "rb"
    
  end if
  
  if length(ft) > 0 then -- Might need to load file from disk
    fn = HttpLocalPath & url[2..len] -- Step over '/'
    z = ""
    ok = 1 -- Defaule to 'LOAD'
    
    tmp = dir(fn) -- Get file details
    if length(tmp) > 0 then -- Have file date/time stamp
      if length(tmp[1]) > 8 then
        dt = tmp[1][4..9] -- File date/time (y,m,d h,m,s)
      end if
    end if
    --HttpDebug(sprintf("FDT=%s Len=%d",{HttpInetDate(dt),length(dt)}))
    
    if length(ims) > 0 then -- "If-Modified-Since" date-time specified
      --HttpDebug(sprintf("IMS=%s Len=%d",{HttpInetDate(ims),length(ims)}))
      
      if compare(dt,ims) <= 0 then -- File has not been modified ..
        ok = 0 -- .. so don't load, just return 304
      end if
    end if
    
    if ok then -- Need to load file
      h = open(fn,ft)
      if h > 0 then -- File opened OK
        rc = 200 -- Result code OK
        byt = getc(h) -- Get 1st byte
        while byt >= 0 do
          z = z & byt
          byt = getc(h) -- Get the rest
        end while
        close(h)
      else -- Not found
        rc = 404
      end if
    else
      rc = 304 -- Not modified
    end if
    q = {rc,z,ct,dt}
    
  else -- Content came from External EGI function
    
  end if
  
  return q
end function
-- Returns {result-code,content,content-type,content-date-time}


function HttpPostDialog(sequence url,sequence head)
  integer ptr,len
  sequence h1,h2
  
  ptr = match(crlf2,head) -- Search for 2 * CRLFs
  if ptr > 1 then -- Re-assemble to match GET data format
    len = length(head)
    h1 = head[1..ptr-1]
    h2 = head[ptr+4..len]
    url = url & '?' & h2
    head = h1
    
    --HttpDebug("HEAD={" & head & "}")
  end if
  
  return HttpGetDialog(url,head)
end function

procedure HttpLog(sequence rx,sequence tx)
  integer h
  sequence dtg,t
  
  t = HttpNow()
  dtg = sprintf("%04d-%02d-%02d %02d:%02d:%02d",{t[1],t[2],t[3],t[4],t[5],t[6]})
  
  h = open("HTTP-Lib.LOG","ab")
  if h > 0 then -- Write dialog
    printf(h,"DateTime: %s\n%s\n%s\n",{dtg,rx,tx})
    puts(h,repeat('-',40) & crlf)
    close(h)
  end if
end procedure

-- This is where the dialog between browser & server is handled :-

-- Example data :-
-- GET /index.htm HTTP/1.1 <
-- Accept: */* <
-- Referer: http://127.0.0.1/index.htm <
-- Accept-Language: en-gb <
-- Accept-Encoding: gzip, deflate <
-- If-Modified-Since: Sun, 17 Nov 2002 13:44:24 GMT <
-- User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows)  <
-- Host: 127.0.0.1 <
-- Connection: Keep-Alive <

global function HttpDialog(sequence rx)
  sequence z,tx,sh,cmd,data,head,q
  integer  len,ptr,pt2,h
  integer  rc -- Return code 200,404 etc
  integer  cl -- Content length
  sequence ct -- Content type (text/html | image/gif |...)
  sequence dt -- Content Date-Time stamp
  
  q = {-1,"","",""} -- Safe default
  rc = 0
  cl = 0
  dt = {}
  tx = ""
  len = length(rx)
  ptr = 0
  
  if len > 0 then -- RX contains data
    pt2 = len -- Just in case !!
    for i = 1 to len do
      if rx[i] = ' ' then -- Found space
        if ptr = 0 then -- 1st space
          ptr = i
        else            -- 2nd space
          pt2 = i
          exit
        end if
      end if
    end for
    
    if ptr > 1 then -- Divide in to command, data & header
      cmd = lower(rx[1..ptr-1]) -- eg get|post|head| ...
      data = rx[ptr+1..pt2-1] -- eg /index.htm
      head = rx[pt2+1..len]
      
      if    compare(cmd,"get") = 0 then -- Do 'GET'
        q = HttpGetDialog(data,head)
        
      elsif compare(cmd,"head") = 0 then -- Do 'HEAD'
        q = {200,"","",""}
        
      elsif compare(cmd,"post") = 0 then -- Do 'POST'
        q = HttpPostDialog(data,head)
        
      else -- Handle suspect commands and requests
        q = {405,"","",""}
        
      end if
    end if
  end if
  
  if length(q) < 4 then -- Ooops !!
    q = {500,"","",""} -- Dummy entry
  end if
  
  sh ="" -- Server header
  if q[1] >= 0 then -- Got request and data, now send response
    rc = q[1] -- return code
    z  = q[2] -- content
    ct = q[3] -- content type
    dt = q[4] -- Date-Time stamp
    cl = length(z)
    -- Server return header
    sh &= sprintf("HTTP/1.0 %d %s\n",{rc,ReturnCode[rc]})
    sh &= sprintf("Server: Renaissance / Eu-%s / %s\n",{HttpOS,HttpLibVer})
    sh &= sprintf("Content-Type: %s\n",{ct})
    sh &= sprintf("Content-Length: %d\n",{cl})
    if length(dt) > 0 then -- Date-Time stamp
      sh &= sprintf("Last-Modified: %s\n",{HttpInetDate(dt)})
    end if
    tx = sh & crlf & z -- Assemble response
  else -- Not quite sure how to handle this !
    tx = tx & sprintf("HTTP/1.0 %d %s\n\n",{rc,ReturnCode[rc]})
  end if
  
  HttpLog(rx,sh) -- Send to log file
  
  return tx
end function



ReturnCode[200] = "OK"
ReturnCode[304] = "Not modified"
ReturnCode[404] = "Not found"
ReturnCode[405] = "Method Not Allowed"
ReturnCode[500] = "Internal Server Error"

-- Here is a complete list of return codes
-- 100 Continue
-- 101 Switching Protocols
-- 201 Created
-- 202 Accepted
-- 203 Non-Authoritative Information
-- 204 No Content
-- 205 Reset Content
-- 206 Parial Content
-- 300 Multiple Choices
-- 301 Moved Permanently
-- 302 Found
-- 303 See Other
-- 305 Use Proxy
-- 307 Temporary Redirect
-- 400 Bad Request
-- 401 Unauthorized
-- 402 Payment Required
-- 403 Forbidden
-- 406 Not Acceptable
-- 407 Proxy Authentication Required
-- 408 Request Time-out
-- 409 Conflict
-- 410 Gone
-- 411 Length Required
-- 412 Precondition Failed
-- 413 Request Entity Too Large
-- 414 Request-URI Too Large
-- 415 Unsupported Media Type
-- 416 Requested range not satisfiable
-- 417 Expectation Failed
-- 501 Not Implemented
-- 502 Bad Gateway
-- 503 Service Unavailable
-- 504 Gateway Time-out
-- 505 HTTP Version not supported | extension-code

if    HttpOSID = 1 then
  HttpOS = "DOS32"
elsif HttpOSID = 2 then
  HttpOS = "Win32"
elsif HttpOSID = 3 then
  HttpOS = "Linux"
end if
